## mlton 20130715

=== Makefile ===
## Copyright (C) 2009,2011,2013 Matthew Fluet.
 # Copyright (C) 1999-2007 Henry Cejtin, Matthew Fluet, Suresh
 #    Jagannathan, and Stephen Weeks.
 # Copyright (C) 1997-2000 NEC Research Institute.
 #
 # MLton is released under a BSD-style license.
 # See the file MLton-LICENSE for details.
 ##

export TARGET := self
export TARGET_ARCH := $(shell bin/host-arch)
export TARGET_OS := $(shell bin/host-os)
ROOT := $(shell pwd)
BUILD := $(ROOT)/build
SRC := $(ROOT)
BIN := $(BUILD)/bin
LIB := $(BUILD)/lib
INC := $(LIB)/include
COMP := $(SRC)/mlton
RUN := $(SRC)/runtime
MLTON := $(BIN)/mlton
AOUT := mlton-compile
ifeq (mingw, $(TARGET_OS))
EXE := .exe
else
EXE :=
endif
MLBPATHMAP := $(LIB)/mlb-path-map
SPEC := package/rpm/mlton.spec
LEX := mllex
PROF := mlprof
YACC := mlyacc
NLFFIGEN := mlnlffigen
PATH := $(BIN):$(SRC)/bin:$(shell echo $$PATH)
CP := /bin/cp -fpR
GZIP := gzip --force --best
RANLIB := ranlib

# If we're compiling with another version of MLton, then we want to do
# another round of compilation so that we get a MLton built without
# stubs.
ifeq (other, $(shell if [ ! -x "$(BIN)/mlton" ]; then echo other; fi))
	BOOTSTRAP_OTHER:=true
else
	BOOTSTRAP_OTHER:=false
endif

ifeq ($(origin VERSION), undefined)
	VERSION := $(shell date +%Y%m%d)
endif
ifeq ($(origin RELEASE), undefined)
	RELEASE := 1
endif

.PHONY: all
all:
	$(MAKE) docs all-no-docs

.PHONY: all-no-docs
all-no-docs:
	$(MAKE) dirs runtime compiler basis-no-check script mlbpathmap constants libraries tools
# Remove $(AOUT) so that the $(MAKE) compiler below will remake MLton.
# We also want to re-run the just-built tools (mllex and mlyacc)
# because they may be better than those that were used for the first
# round of compilation.  So, we clean out the front end.
ifeq (true, $(BOOTSTRAP_OTHER))
	rm -f "$(COMP)/$(AOUT)$(EXE)"
	$(MAKE) -C "$(COMP)/front-end" clean
endif
	$(MAKE) compiler basis
	@echo 'Build of MLton succeeded.'

.PHONY: basis-no-check
basis-no-check:
	mkdir -p "$(LIB)/sml"
	rm -rf "$(LIB)/sml/basis"
	$(CP) "$(SRC)/basis-library/." "$(LIB)/sml/basis"
	find "$(LIB)/sml/basis" -name .gitignore | xargs rm -rf

.PHONY: basis
basis:
	$(MAKE) basis-no-check
	@echo 'Type checking basis.'
	"$(MLTON)" -disable-ann deadCode \
		-stop tc \
		'$$(SML_LIB)/basis/libs/all.mlb' \
		>/dev/null

.PHONY: bootstrap-nj
bootstrap-nj:
	$(MAKE) nj-mlton
	$(MAKE) all

.PHONY: clean
clean:
	bin/clean

.PHONY: clean-git
clean-git:
	find . -type d -name .git | xargs rm -rf

.PHONY: compiler
compiler:
	$(MAKE) -C "$(COMP)"
	$(CP) "$(COMP)/$(AOUT)$(EXE)" "$(LIB)/"

.PHONY: constants
constants:
	@echo 'Creating constants file.'
	"$(BIN)/mlton" -target "$(TARGET)" -build-constants true >tmp.c
	"$(BIN)/mlton" -target "$(TARGET)" -output tmp tmp.c
	./tmp >"$(LIB)/targets/$(TARGET)/constants"
	rm -f tmp tmp.exe tmp.c

.PHONY: debugged
debugged:
	$(MAKE) -C "$(COMP)" "AOUT=$(AOUT).debug" COMPILE_ARGS="-debug true -const 'Exn.keepHistory true' -profile-val true -const 'MLton.debug true' -drop-pass 'deepFlatten'"
	$(CP) "$(COMP)/$(AOUT).debug" "$(LIB)/"
	sed 's/mlton-compile/mlton-compile.debug/' < "$(MLTON)" > "$(MLTON).debug"
	chmod a+x "$(MLTON).debug"

.PHONY: dirs
dirs:
	mkdir -p "$(BIN)" "$(INC)"
	mkdir -p "$(LIB)/targets/$(TARGET)/include"
	mkdir -p "$(LIB)/targets/$(TARGET)/sml"

.PHONY: docs
docs: dirs
	$(MAKE) -C "$(LEX)" docs
	$(MAKE) -C "$(YACC)" docs
	$(MAKE) -C doc/guide

LIBRARIES := ckit-lib cml mllpt-lib mlnlffi-lib mlrisc-lib mlyacc-lib smlnj-lib

.PHONY: libraries-no-check
libraries-no-check:
	mkdir -p "$(LIB)/sml"
	cd "$(LIB)/sml" && rm -rf $(LIBRARIES)
	$(MAKE) -C "$(SRC)/lib/ckit-lib"
	$(MAKE) -C "$(SRC)/lib/mllpt-lib"
	$(MAKE) -C "$(SRC)/lib/mlnlffi-lib"
	$(MAKE) -C "$(SRC)/lib/mlrisc-lib"
	$(MAKE) -C "$(SRC)/lib/smlnj-lib"
	$(CP) "$(SRC)/lib/cml/." "$(LIB)/sml/cml"
	$(CP) "$(SRC)/lib/ckit-lib/ckit/." "$(LIB)/sml/ckit-lib"
	$(CP) "$(SRC)/lib/mlnlffi-lib/." "$(LIB)/sml/mlnlffi-lib"
	$(CP) "$(SRC)/lib/mlrisc-lib/MLRISC/." "$(LIB)/sml/mlrisc-lib"
	$(CP) "$(SRC)/lib/mllpt-lib/ml-lpt/lib/." "$(LIB)/sml/mllpt-lib"
	$(CP) "$(SRC)/lib/mlyacc-lib/." "$(LIB)/sml/mlyacc-lib"
	$(CP) "$(SRC)/lib/smlnj-lib/smlnj-lib/." "$(LIB)/sml/smlnj-lib"
	find "$(LIB)/sml" -type d -name .cm | xargs rm -rf
	find "$(LIB)/sml" -name .gitignore | xargs rm -rf

.PHONY: libraries
libraries:
	$(MAKE) libraries-no-check
	for f in $(LIBRARIES); do				\
		echo "Type checking $$f library.";		\
		"$(MLTON)" -disable-ann deadCode		\
			-stop tc				\
			'$$(SML_LIB)/'"$$f/$$f.mlb"		\
			>/dev/null;				\
	done

.PHONY: mlbpathmap
mlbpathmap:
	touch "$(MLBPATHMAP)"
	( echo 'MLTON_ROOT $$(LIB_MLTON_DIR)/sml';	\
	  echo 'SML_LIB $$(LIB_MLTON_DIR)/sml'; )	\
		>>"$(MLBPATHMAP).tmp"
	mv "$(MLBPATHMAP).tmp" "$(MLBPATHMAP)"

.PHONY: polyml-mlton
polyml-mlton:
	$(MAKE) dirs runtime
	$(MAKE) -C "$(COMP)" polyml-mlton
	$(CP) "$(COMP)/mlton-polyml$(EXE)" "$(LIB)/"
	$(MAKE) script basis-no-check mlbpathmap constants libraries-no-check
	@echo 'Build of MLton succeeded.'

.PHONY: profiled
profiled:
	for t in alloc count time; do					\
		$(MAKE) -C "$(COMP)" "AOUT=$(AOUT).$$t"			\
			COMPILE_ARGS="-profile $$t";			\
		$(CP) "$(COMP)/$(AOUT).$$t" "$(LIB)/";			\
		sed "s/mlton-compile/mlton-compile.$$t/" 		\
			<"$(MLTON)" 					\
			>"$(MLTON).$$t";				\
		chmod a+x "$(MLTON).$$t";				\
	done

.PHONY: runtime
runtime:
	@echo 'Compiling MLton runtime system for $(TARGET).'
	$(MAKE) -C runtime
	$(CP) include/*.h "$(INC)/"
	$(CP) runtime/*.a "$(LIB)/targets/$(TARGET)/"
	$(CP) runtime/gen/sizes "$(LIB)/targets/$(TARGET)/"
	$(CP) runtime/gen/c-types.sml "$(LIB)/targets/$(TARGET)/sml/"
	echo "$(TARGET_OS)" > "$(LIB)/targets/$(TARGET)/os"
	echo "$(TARGET_ARCH)" > "$(LIB)/targets/$(TARGET)/arch"
	$(CP) runtime/gen/basis-ffi.sml \
		basis-library/primitive/basis-ffi.sml
	$(CP) runtime/*.h "$(INC)/"
	mv "$(INC)/c-types.h" "$(LIB)/targets/$(TARGET)/include"
	for d in basis basis/Real basis/Word gc platform util; do	\
		mkdir -p "$(INC)/$$d";					\
		$(CP) runtime/$$d/*.h "$(INC)/$$d";			\
	done
	for x in "$(LIB)/targets/$(TARGET)"/*.a; do $(RANLIB) "$$x"; done

.PHONY: script
script:
	$(CP) bin/mlton-script "$(MLTON)"
	chmod a+x "$(MLTON)"
	$(CP) "$(SRC)/bin/platform" "$(LIB)"
	$(CP) "$(SRC)/bin/static-library" "$(LIB)"
ifeq (mingw, $(TARGET_OS))
	$(CP) "$(SRC)/bin/static-library.bat" "$(LIB)"
endif

.PHONY: smlnj-mlton
smlnj-mlton:
	$(MAKE) dirs runtime
	$(MAKE) -C "$(COMP)" smlnj-mlton
	smlnj_heap_suffix=`echo 'TextIO.output (TextIO.stdErr, SMLofNJ.SysInfo.getHeapSuffix ());' | sml 2>&1 1> /dev/null` && $(CP) "$(COMP)/mlton-smlnj.$$smlnj_heap_suffix" "$(LIB)/"
	$(MAKE) script basis-no-check mlbpathmap constants libraries-no-check
	@echo 'Build of MLton succeeded.'

.PHONY: smlnj-mlton-dual
smlnj-mlton-dual:
	$(MAKE) SMLNJ_CM_SERVERS_NUM=2 smlnj-mlton

.PHONY: smlnj-mlton-quad
smlnj-mlton-quad:
	$(MAKE) SMLNJ_CM_SERVERS_NUM=4 smlnj-mlton

.PHONY: traced
traced:
	$(MAKE) -C "$(COMP)" "AOUT=$(AOUT).trace" COMPILE_ARGS="-const 'Exn.keepHistory true' -profile-val true -const 'MLton.debug true' -drop-pass 'deepFlatten'"
	$(CP) "$(COMP)/$(AOUT).trace" "$(LIB)/"
	sed 's/mlton-compile/mlton-compile.trace/' < "$(MLTON)" > "$(MLTON).trace"
	chmod a+x "$(MLTON).trace"

.PHONY: tools
tools:
	$(MAKE) -C "$(LEX)"
	$(MAKE) -C "$(NLFFIGEN)"
	$(MAKE) -C "$(PROF)"
	$(MAKE) -C "$(YACC)"
	$(CP) "$(LEX)/$(LEX)$(EXE)"		\
		"$(NLFFIGEN)/$(NLFFIGEN)$(EXE)"	\
		"$(PROF)/$(PROF)$(EXE)"		\
		"$(YACC)/$(YACC)$(EXE)"		\
		"$(BIN)/"

.PHONY: version
version:
	@echo 'Instantiating version numbers.'
	for f in							\
		"$(SPEC)"						\
		package/freebsd/Makefile				\
		mlton/control/version_sml.src				\
		doc/guide/conf/asciidoc-mlton.flags			\
	; do								\
		if grep -q 'MLTONVERSION' "$$f"; then			\
			sed "s/\(.*\)MLTONVERSION\(.*\)/\1$(VERSION)\2/" <"$$f" >z && 	\
			mv z "$$f";							\
		fi;							\
	done
	if grep -q '^Release:$$' "$(SPEC)"; then			\
		sed <"$(SPEC)" >z "/^Release:/s;.*;Release: $(RELEASE);"; 		\
		mv z "$(SPEC)";								\
	fi

.PHONY: check
check:
	./bin/regression

# The TBIN and TLIB are where the files are going to be after installing.
# The DESTDIR and is added onto them to indicate where the Makefile actually
# puts them.
DESTDIR := $(CURDIR)/install
PREFIX := /usr
ifeq ($(findstring $(TARGET_OS), darwin freebsd solaris), $(TARGET_OS))
PREFIX := /usr/local
endif
ifeq ($(TARGET_OS), mingw)
PREFIX := /mingw
endif
prefix := $(PREFIX)
MAN_PREFIX_EXTRA :=
TBIN := $(DESTDIR)$(prefix)/bin
ULIB := lib/mlton
TLIB := $(DESTDIR)$(prefix)/$(ULIB)
TMAN := $(DESTDIR)$(prefix)$(MAN_PREFIX_EXTRA)/man/man1
TDOC := $(DESTDIR)$(prefix)/share/doc/mlton
ifeq ($(findstring $(TARGET_OS), solaris mingw), $(TARGET_OS))
TDOC := $(DESTDIR)$(prefix)/doc/mlton
endif
TEXM := $(TDOC)/examples

GZIP_MAN := true
ifeq ($(TARGET_OS), solaris)
GZIP_MAN := false
endif

.PHONY: install
install: install-no-strip install-strip

.PHONY: install-no-strip
install-no-strip: install-docs install-no-docs move-docs 

MAN_PAGES :=  \
	mllex.1 \
	mlnlffigen.1 \
	mlprof.1 \
	mlton.1 \
	mlyacc.1

.PHONY: install-no-docs
install-no-docs:
	mkdir -p "$(TLIB)" "$(TBIN)" "$(TMAN)"
	$(CP) "$(LIB)/." "$(TLIB)/"
	sed "/^lib=/s;.*;lib='$(prefix)/$(ULIB)';"			\
		<"$(BIN)/mlton" >"$(TBIN)/mlton"
	chmod a+x "$(TBIN)/mlton"
	if [ -x "$(BIN)/mlton.trace" ]; then                            \
		sed "/^lib=/s;.*;lib='$(prefix)/$(ULIB)';"		\
			<"$(BIN)/mlton.trace" >"$(TBIN)/mlton.trace";   \
		chmod a+x "$(TBIN)/mlton.trace";                        \
	fi
	if [ -x "$(BIN)/mlton.debug" ]; then                            \
		sed "/^lib=/s;.*;lib='$(prefix)/$(ULIB)';"		\
			<"$(BIN)/mlton.debug" >"$(TBIN)/mlton.debug";   \
		chmod a+x "$(TBIN)/mlton.debug";                        \
	fi
	cd "$(BIN)" && $(CP) "$(LEX)$(EXE)" "$(NLFFIGEN)$(EXE)"		\
		 "$(PROF)$(EXE)" "$(YACC)$(EXE)" "$(TBIN)/"
	( cd "$(SRC)/man" && tar cf - $(MAN_PAGES)) | \
		( cd "$(TMAN)/" && tar xf - )
	if $(GZIP_MAN); then						\
		cd "$(TMAN)" && $(GZIP) $(MAN_PAGES);			\
	fi

.PHONY: install-strip
install-strip:
	case "$(TARGET_OS)" in						\
	aix|cygwin|darwin|solaris)					\
	;;								\
	*)								\
		for f in "$(TLIB)/$(AOUT)$(EXE)" "$(TBIN)/$(LEX)$(EXE)"	\
			"$(TBIN)/$(NLFFIGEN)$(EXE)" "$(TBIN)/$(PROF)$(EXE)" \
			"$(TBIN)/$(YACC)$(EXE)"; do			\
			strip --remove-section=.comment			\
				--remove-section=.note "$$f";		\
		done							\
	esac

.PHONY: install-docs
install-docs:
	mkdir -p "$(TDOC)"
	(								\
		cd "$(SRC)/doc" &&					\
		$(CP) changelog examples license README "$(TDOC)/"	\
	)
	if [ -d "$(SRC)/doc/guide/localhost" ]; then			\
		$(CP) "$(SRC)/doc/guide/localhost" "$(TDOC)/guide";	\
	fi
	if [ -r "$(SRC)/doc/guide/mlton-guide.pdf" ]; then		\
		$(CP) "$(SRC)/doc/guide/mlton-guide.pdf" "$(TDOC)/";	\
	fi
	(								\
		cd "$(SRC)/util" &&					\
		$(CP) cmcat cm2mlb "$(TDOC)/"				\
	)
	for f in callcc command-line hello-world same-fringe signals	\
			size taut thread1 thread2 thread-switch timeout \
		; do							\
		$(CP) "$(SRC)/regression/$$f.sml" "$(TEXM)/";		\
	done
	if [ -r "$(LEX)/$(LEX).pdf" ]; then				\
		$(CP) "$(LEX)/$(LEX).pdf" "$(TDOC)/";			\
	fi
	if [ -r "$(YACC)/$(YACC).pdf" ]; then				\
		$(CP) "$(YACC)/$(YACC).pdf" "$(TDOC)/";			\
	fi
	find "$(TDOC)/" -name .gitignore | xargs rm -rf
	find "$(TEXM)/" -name .gitignore | xargs rm -rf


.PHONY: move-docs
move-docs:	install-docs install-no-docs
	cd "$(TLIB)/sml"; for i in *; do test -d "$(TDOC)/$$i" || mkdir -p "$(TDOC)/$$i"; done
	cd "$(TLIB)/sml"; for i in */[Dd]oc; do mv "$$i" "$(TDOC)/$$i"; done
	cd "$(TLIB)/sml"; for i in */README*; do mv "$$i" "$(TDOC)/$$i"; done

.PHONY: release
release: version
	tar cvzf ../mlton-$(VERSION).src.tgz \
		--exclude .git --exclude package \
		--transform "s@^@mlton-$(VERSION)/@S" \
		*

BSDSRC := /tmp/mlton-$(VERSION)
.PHONY: freebsd
freebsd:
	$(MAKE) clean clean-git version
	rm -rf "$(BSDSRC)"
	mkdir -p "$(BSDSRC)"
	( cd $(SRC) && tar -cpf - . ) | ( cd "$(BSDSRC)" && tar -xpf - )
	cd /tmp && tar -cpf - mlton-$(VERSION) | \

=== basis-library/Makefile ===
## Copyright (C) 2010,2013 Matthew Fluet.
 # Copyright (C) 1999-2006, 2008 Henry Cejtin, Matthew Fluet, Suresh
 #    Jagannathan, and Stephen Weeks.
 # Copyright (C) 1997-2000 NEC Research Institute.
 #
 # MLton is released under a BSD-style license.
 # See the file MLton-LICENSE for details.
 ##

SRC = $(shell cd .. && pwd)
BUILD = $(SRC)/build
BIN = $(BUILD)/bin
MLTON = mlton
PATH = $(BIN):$(shell echo $$PATH)

all:

.PHONY: clean
clean:
	../bin/clean


RESOLVE_SCOPES = program topdec strdec dec
OBJPTR_MAPS = objptr-rep32.map objptr-rep64.map 
HEADER_MAPS = header-word32.map header-word64.map
SEQINDEX_MAPS = seqindex-int32.map seqindex-int64.map 
DEFAULT_CHAR = char8
DEFAULT_INT = int32 int64 intinf
DEFAULT_REAL = real32 real64
DEFAULT_WORD = word32 word64

.PHONY: def-use
def-use:
	"$(MLTON)" -disable-ann deadCode -stop tc -show-types true \
		-prefer-abs-paths true -show-def-use basis-library.def-use \
		libs/all.mlb

.PHONY: type-check-def
type-check-def:
	"$(MLTON)" -disable-ann deadCode -stop tc -show-types true \
		libs/all.mlb

.PHONY: type-check-all
type-check-all:
	for resolvescope in $(RESOLVE_SCOPES); do \
	for objptrrep in $(OBJPTR_MAPS); do \
	for header in $(HEADER_MAPS); do \
	for seqindex in $(SEQINDEX_MAPS); do \
	for defchar in $(DEFAULT_CHAR); do \
	for defint in $(DEFAULT_INT); do \
	for defreal in $(DEFAULT_REAL); do \
	for defword in $(DEFAULT_WORD); do \
	echo "Type checking: $$resolvescope  $$objptrrep $$header $$seqindex  $$defchar $$defint $$defreal $$defword"; \
	echo "$(MLTON)" -disable-ann deadCode -disable-ann resolveScope -default-ann "\"resolveScope $$resolvescope\"" -stop tc -show-types true \
		-mlb-path-map "maps/$$objptrrep" \
		-mlb-path-map "maps/$$header" \
		-mlb-path-map "maps/$$seqindex" \
		-default-type "$$defchar" \
		-default-type "$$defint" \
		-default-type "$$defreal" \
		-default-type "$$defword" \
		libs/all.mlb; \
	"$(MLTON)" -disable-ann deadCode -disable-ann resolveScope -default-ann "resolveScope $$resolvescope" -stop tc -show-types true \
		-mlb-path-map "maps/$$objptrrep" \
		-mlb-path-map "maps/$$header" \
		-mlb-path-map "maps/$$seqindex" \
		-default-type "$$defchar" \
		-default-type "$$defint" \
		-default-type "$$defreal" \
		-default-type "$$defword" \
		libs/all.mlb; \
	done; done; done; done; done; done; done; done;

=== benchmark/Makefile ===
## Copyright (C) 2009 Matthew Fluet.
 # Copyright (C) 1999-2007 Henry Cejtin, Matthew Fluet, Suresh
 #    Jagannathan, and Stephen Weeks.
 # Copyright (C) 1997-2000 NEC Research Institute.
 #
 # MLton is released under a BSD-style license.
 # See the file MLton-LICENSE for details.
 ##

SRC := $(shell cd .. && pwd)
BUILD := $(SRC)/build
BIN := $(BUILD)/bin
LIB := $(BUILD)/lib
MLTON := mlton
TARGET := self
FLAGS := -target $(TARGET)	\
	-default-ann 'sequenceNonUnit warn' \
	-default-ann 'warnUnused true'
NAME := benchmark
PATH := $(BIN):$(shell echo $$PATH)

all: 	$(NAME)

$(NAME): $(NAME).mlb $(shell PATH="$(BIN):$$PATH" && "$(MLTON)" -stop f $(NAME).mlb)
	@echo 'Compiling $(NAME)'
	"$(MLTON)" $(FLAGS) $(NAME).mlb

.PHONY: clean
clean:
	../bin/clean

BENCH := barnes-hut boyer checksum count-graphs DLXSimulator fft fib flat-array hamlet imp-for knuth-bendix lexgen life logic mandelbrot matrix-multiply md5 merge mlyacc model-elimination mpuz nucleic output1 peek psdes-random ratio-regions ray raytrace simple smith-normal-form tailfib tak tensor tsp tyan vector-concat vector-rev vliw wc-input1 wc-scanStream zebra zern
FPBENCH := barnes-hut fft hamlet mandelbrot matrix-multiply nucleic ray raytrace simple tensor tsp tyan vliw zern

BFLAGS := -mlton "/usr/bin/mlton" -mlton "mlton -optimize-ssa {false,true}"
BFLAGS := -wiki -mlton "/usr/bin/mlton" -mlkit -mosml -poly -smlnj
BFLAGS := -mlton "$(BIN)/mlton"

.PHONY: test
test: $(NAME)
	cd tests && ../benchmark $(BFLAGS) $(BENCH)

QBENCH := $(BENCH)
QBFLAGS := -mlton "~/devel/mlton/mlton-20061119-1.x86-darwin/build/bin/mlton"
QBFLAGS += -mlton "~/devel/mlton/mlton.svn.trunk/build/bin/mlton"
# QBFLAGS += -mlton "~/devel/mlton/mlton.svn.trunk.inline/build/bin/mlton -drop-pass introduceLoops1 -drop-pass loopInvariant1 -inline-leafa-loops true -inline-leafa-repeat false -inline-leafa-size 20 -drop-pass inlineLeaf2"
# QBFLAGS += -mlton "~/devel/mlton/mlton.svn.trunk.inline/build/bin/mlton -inline-leafa-loops true -inline-leafa-repeat true -inline-leafa-size 20 -inline-leafb-loops true -inline-leafb-repeat true -inline-leafb-size 40"
QBFLAGS += -mlton "~/devel/mlton/mlton.svn.trunk.inline/build/bin/mlton"

.PHONY: qtest
qtest: $(NAME)
	cd tests && ../benchmark $(QBFLAGS) $(QBENCH) && $(MAKE) clean

=== bin/Makefile ===
## Copyright (C) 1999-2005 Henry Cejtin, Matthew Fluet, Suresh
 #    Jagannathan, and Stephen Weeks.
 # Copyright (C) 1997-2000 NEC Research Institute.
 #
 # MLton is released under a BSD-style license.
 # See the file MLton-LICENSE for details.
 ##

all:

.PHONY: clean
clean:
	../bin/clean

=== include/Makefile ===
## Copyright (C) 1999-2005 Henry Cejtin, Matthew Fluet, Suresh
 #    Jagannathan, and Stephen Weeks.
 # Copyright (C) 1997-2000 NEC Research Institute.
 #
 # MLton is released under a BSD-style license.
 # See the file MLton-LICENSE for details.
 ##

all:

.PHONY: clean
clean:
	../bin/clean

=== mllex/Makefile ===
## Copyright (C) 2009,2013 Matthew Fluet.
 # Copyright (C) 1999-2006 Henry Cejtin, Matthew Fluet, Suresh
 #    Jagannathan, and Stephen Weeks.
 # Copyright (C) 1997-2000 NEC Research Institute.
 #
 # MLton is released under a BSD-style license.
 # See the file MLton-LICENSE for details.
 ##

SRC := $(shell cd .. && pwd)
BUILD := $(SRC)/build
BIN := $(BUILD)/bin
LIB := $(BUILD)/lib
MLTON := mlton
TARGET := self
FLAGS := -target $(TARGET)
NAME := mllex
PATH := $(BIN):$(shell echo $$PATH)

all:	$(NAME)

$(NAME): $(NAME).mlb $(shell PATH="$(BIN):$$PATH" && "$(MLTON)" -stop f $(NAME).mlb)
	@echo 'Compiling $(NAME)'
	"$(MLTON)" $(FLAGS) $(NAME).mlb

html/index.html: $(TEX_FILES)
	mkdir -p html
	hevea -fix -o html/mllex.html -exec xxdate.exe macros.hva lexgen.tex
	cd html && hacha mllex.html && rm -f mllex.html

PDFLATEX := pdflatex

lexgen.pdf: lexgen.tex
	$(PDFLATEX) lexgen.tex
	$(PDFLATEX) lexgen.tex

mllex.pdf: lexgen.pdf
	cp lexgen.pdf mllex.pdf

DOCS :=
ifneq ($(shell which $(PDFLATEX) 2> /dev/null),)
DOCS += mllex.pdf
endif

.PHONY: docs
docs: $(DOCS)

.PHONY: clean
clean:
	../bin/clean

.PHONY: test
test: $(NAME)
	cp -p ../mlton/front-end/ml.lex . &&			\
	$(NAME) ml.lex &&					\
	diff ml.lex.sml ../mlton/front-end/ml.lex.sml

=== mlnlffigen/Makefile ===
## Copyright (C) 2005-2009 Henry Cejtin, Matthew Fluet, Suresh
 #    Jagannathan, and Stephen Weeks.
 #
 # MLton is released under a BSD-style license.
 # See the file MLton-LICENSE for details.
 ##

SRC := $(shell cd .. && pwd)
BUILD := $(SRC)/build
BIN := $(BUILD)/bin
LIB := $(BUILD)/lib
MLTON := mlton
TARGET := self
FLAGS := -target $(TARGET) -default-ann 'sequenceNonUnit warn'
NAME := mlnlffigen
PATH := $(BIN):$(shell echo $$PATH)

all:	$(NAME)

cppcmd.sml : gen-cppcmd
	./gen-cppcmd > $@

$(NAME): $(NAME).mlb $(shell PATH="$(BIN):$$PATH" && "$(MLTON)" -stop f $(NAME).mlb)
	@echo 'Compiling $(NAME)'
	$(MLTON) $(FLAGS) $(NAME).mlb

.PHONY: clean
clean:
	../bin/clean

=== mlton/Makefile ===
## Copyright (C) 2010,2013 Matthew Fluet.
 # Copyright (C) 1999-2009 Henry Cejtin, Matthew Fluet, Suresh
 #    Jagannathan, and Stephen Weeks.
 # Copyright (C) 1997-2000 NEC Research Institute.
 #
 # MLton is released under a BSD-style license.
 # See the file MLton-LICENSE for details.
 ##

SRC := $(shell cd .. && pwd)
BUILD := $(SRC)/build
BIN := $(BUILD)/bin
HOST_ARCH := $(shell "$(SRC)/bin/host-arch")
HOST_OS := $(shell "$(SRC)/bin/host-os")
LIB := $(BUILD)/lib
TARGET := self
AOUT := mlton-compile
PATH := $(BIN):$(shell echo $$PATH)

FLAGS := @MLton ram-slop 0.7 gc-summary $(RUNTIME_ARGS) --

ifeq (self, $(shell if [ -x "$(BIN)/mlton" ]; then echo self; fi))
  # We're compiling MLton with itself, so don't use any stubs.
  FILE := mlton.mlb
  FLAGS += -default-ann 'sequenceNonUnit warn'
  FLAGS += -default-ann 'warnUnused true'
  # FLAGS += -type-check true
else
# We're compiling MLton with an older version of itself. 
# Use "-align 8" for amd64 to avoid GMP/mul_2exp segfault with a
# mis-aligned limb when compiling with <= 20070826.
ifeq (amd64,$(findstring $(HOST_ARCH), amd64))
  FLAGS += -align 8
endif
ifneq (,$(findstring $(HOST_OS), cygwin mingw))
  # The stubs don't work on Cygwin or MinGW, since they define spawn
  # in terms of fork, and fork doesn't work on Cygwin or MinGW.  So,
  # make without the stubs.
  FILE := mlton.mlb
else
  # We're compiling MLton with an older version of itself, so use the stubs for
  # the MLton structure.
  FILE := mlton-stubs.mlb
endif
endif

FLAGS += -target $(TARGET)
FLAGS += -verbose 2 -output "$(AOUT)"
FLAGS += $(COMPILE_ARGS)

FRONT_END_SOURCES :=		\
	front-end/ml.lex.sml	\
	front-end/ml.grm.sig	\
	front-end/ml.grm.sml	\
	front-end/mlb.lex.sml	\
	front-end/mlb.grm.sig	\
	front-end/mlb.grm.sml

SOURCES :=			\
	$(FILE)			\
	upgrade-basis.sml	\
	$(FRONT_END_SOURCES)	\
	$(filter-out control/version.sml,$(shell if [ -r $(FILE) ]; then mlton -stop f $(FILE) | grep -v " "; fi))

.PHONY: all
all: $(AOUT)

control/version.sml: control/version_sml.src
	cat control/version_sml.src |				\
		sed "s/MLTONVERSION/$$(git log -n1 --pretty="g%h$$(if [ $$(git status --porcelain 2> /dev/null | wc -l) -ne 0 ]; then echo '-dirty'; fi)" 2> /dev/null || echo "???????")/" |	\
		sed "s/MLTONBUILDDATE/$$(LANG=C date)/" |	\
		sed "s/MLTONBUILDNODE/$$(uname -n)/" >		\
		control/version.sml

front-end/%.lex.sml: front-end/%.lex
	$(MAKE) -C front-end $(@F)
front-end/%.grm.sig front-end/%.grm.sml: front-end/%.grm
	$(MAKE) -C front-end $(<F).sig $(<F).sml

# Pass $(PATH) to upgrade-basis because it is run via
# #!/usr/bin/env bash, which resets the path.
upgrade-basis.sml:
	"$(SRC)/bin/upgrade-basis" '$(PATH)' "$(HOST_ARCH)" "$(HOST_OS)" >upgrade-basis.sml

mlton-stubs.mlb: $(shell mlton -stop f ../lib/stubs/mlton-stubs/sources.mlb) $(shell mlton -stop f mlton.mlb)
	(									\
		echo '$$(SML_LIB)/basis/unsafe.mlb';				\
		echo '$$(SML_LIB)/basis/sml-nj.mlb';				\
		echo '$$(SML_LIB)/basis/mlton.mlb';				\
		echo '$$(SML_LIB)/basis/basis.mlb';				\
		echo 'upgrade-basis.sml';					\
		mlton -stop f mlton.mlb | grep -v 'mlb$$' | grep 'mlyacc';	\
		mlton -stop f ../lib/stubs/mlton-stubs/sources.mlb |		\
			grep -v 'mlb$$' | 					\
			grep 'mlton-stubs';					\
		mlton -stop f mlton.mlb |					\
			grep -v 'mlb$$' |					\
			grep -v 'sml/basis' | 					\
			grep -v 'targets' | 					\
			grep -v 'mlyacc';					\
	) > mlton-stubs.mlb

$(AOUT): $(SOURCES)
	rm -f upgrade-basis.sml
	$(MAKE) upgrade-basis.sml
	rm -f control/version.sml
	$(MAKE) control/version.sml
	@echo 'Compiling mlton (takes a while)'
	mlton $(FLAGS) $(FILE)

.PHONY: def-use
def-use: mlton.def-use

mlton.def-use: $(SOURCES)
	mlton $(FLAGS) -stop tc -prefer-abs-paths true -show-def-use mlton.def-use $(FILE)

.PHONY: clean
clean:
	../bin/clean

#
# The following rebuilds the heap file for the SML/NJ compiled version
# of MLton.
#
SMLNJ := sml
SMLNJ_CM_SERVERS_NUM := 0

.PHONY: smlnj-mlton
smlnj-mlton: $(FRONT_END_SOURCES)
	rm -f control/version.sml
	$(MAKE) control/version.sml
	(									\
		echo 'SMLofNJ.Internals.GC.messages false;';			\
		echo '#set CM.Control.verbose false;';				\
		echo '#set CM.Control.warn_obsolete false;';			\
		echo 'Control.polyEqWarn := false;';				\
		echo 'local';							\
		echo 'fun loop 0 = () | loop n = (CM.Server.start {cmd = (CommandLine.name (), ["@CMslave"]), name = "server" ^ (Int.toString n), pathtrans = NONE, pref = 0}; loop (n - 1));'; \
		echo 'in';							\
		echo 'val _ = loop $(SMLNJ_CM_SERVERS_NUM);';			\
		echo 'end;';							\
		echo 'if (CM.make "mlton-smlnj.cm") handle _ => false';		\
		echo '   then ()';						\
		echo '   else OS.Process.exit OS.Process.failure;'; 		\
		echo 'SMLofNJ.exportFn("mlton-smlnj",Main.main);'		\
	) | "$(SMLNJ)"

#
# The following rebuilds the executable file for the Poly/ML compiled
# version of MLton.
#
POLYML	:= poly

.PHONY: polyml-mlton
polyml-mlton: mlton-polyml.use $(FRONT_END_SOURCES)
	rm -f control/version.sml
	$(MAKE) control/version.sml
	(									\
		echo 'use "mlton-polyml.use";';					\
		echo 'PolyML.export("mlton-polyml", Main.mainWrapped);';	\
	) | "$(POLYML)"
	$(CC) -o mlton-polyml mlton-polyml.o -lpolymain -lpolyml
	rm -f mlton-polyml.o

mlton-polyml.use: ../lib/stubs/basis-stubs-for-polyml/sources.use ../lib/stubs/mlton-stubs-for-polyml/sources.use $(shell mlton -stop f ../lib/stubs/mlton-stubs/sources.mlb) $(filter-out control/version.sml,$(shell mlton -stop f mlton.mlb))
	(									\
		cat ../lib/stubs/basis-stubs-for-polyml/sources.use |		\
			sed 's|use "\(.*\)";|../lib/stubs/basis-stubs-for-polyml/\1|'; \
		mlton -stop f mlton.mlb | grep -v 'mlb$$' | grep 'mlyacc';	\
		cat ../lib/stubs/mlton-stubs-for-polyml/sources.use |		\
			sed 's|use "\(.*\)";|../lib/stubs/mlton-stubs-for-polyml/\1|'; \
		mlton -stop f ../lib/stubs/mlton-stubs/sources.mlb |		\
			grep -v 'mlb$$' | 					\
			grep 'mlton-stubs';					\
		mlton -stop f mlton.mlb |					\
			grep -v 'mlb$$' |					\
			grep -v 'sml/basis' | 					\
			grep -v 'targets' | 					\
			grep -v 'mlton-stubs' |					\
			grep -v 'mlyacc' |					\
			grep -v 'call-main.sml';				\
	) | sed 's|\(.*\)|use "\1";|' > mlton-polyml.use

=== mlyacc/Makefile ===
## Copyright (C) 2009,2013 Matthew Fluet.
 # Copyright (C) 1999-2006 Henry Cejtin, Matthew Fluet, Suresh
 #    Jagannathan, and Stephen Weeks.
 # Copyright (C) 1997-2000 NEC Research Institute.
 #
 # MLton is released under a BSD-style license.
 # See the file MLton-LICENSE for details.
 ##

SRC := $(shell cd .. && pwd)
BUILD := $(SRC)/build
BIN := $(BUILD)/bin
LIB := $(BUILD)/lib
MLTON := mlton
TARGET := self
FLAGS := -target $(TARGET)
NAME := mlyacc
PATH := $(BIN):$(shell echo $$PATH)

ifeq (mllex, $(shell if mllex >/dev/null 2>&1 || [ $$? != 127 ] ; then echo mllex; fi))
MLLEX := mllex
else
ifeq (ml-lex, $(shell if ml-lex >/dev/null 2>&1 || [ $$? != 127 ] ; then echo ml-lex; fi))
MLLEX := ml-lex
else
MLLEX := no-mllex
endif
endif

ifeq (mlyacc, $(shell if mlyacc >/dev/null 2>&1 || [ $$? != 127 ] ; then echo mlyacc; fi))
MLYACC := mlyacc
else
ifeq (ml-yacc, $(shell if ml-lex >/dev/null 2>&1 || [ $$? != 127 ] ; then echo ml-yacc; fi))
MLYACC := ml-yacc
else
MLYACC := no-mlyacc
endif
endif

all:	$(NAME)

$(NAME): $(NAME).mlb $(shell PATH="$(BIN):$$PATH" && "$(MLTON)" -stop f $(NAME).mlb)
	@echo 'Compiling $(NAME)'
	"$(MLTON)" $(FLAGS) $(NAME).mlb

src/yacc.lex.sml: src/yacc.lex
	rm -f src/yacc.lex.sml && \
		$(MLLEX) src/yacc.lex && \
		chmod -w src/yacc.lex.sml

src/%.grm.sig src/%.grm.sml: src/%.grm
	rm -f $<.* 
	$(MLYACC) $<
	chmod -w $<.*

PDFLATEX := pdflatex

doc/mlyacc.pdf:
	$(MAKE) -C doc mlyacc.pdf

mlyacc.pdf: doc/mlyacc.pdf
	cp doc/mlyacc.pdf .

DOCS :=
ifneq ($(shell which $(PDFLATEX) 2> /dev/null),)
DOCS += mlyacc.pdf
endif

.PHONY: docs
docs: $(DOCS)

.PHONY: clean
clean:
	../bin/clean

.PHONY: test
test: $(NAME)
	cp -p ../mlton/front-end/ml.grm . &&			\
	$(NAME) ml.grm &&					\
	diff ml.grm.sig ../mlton/front-end/ml.grm.sig &&	\
	diff ml.grm.sml ../mlton/front-end/ml.grm.sml

=== runtime/Makefile ===
## Copyright (C) 2010-2013 Matthew Fluet.
 # Copyright (C) 1999-2009 Henry Cejtin, Matthew Fluet, Suresh
 #    Jagannathan, and Stephen Weeks.
 # Copyright (C) 1997-2000 NEC Research Institute.
 #
 # MLton is released under a BSD-style license.
 # See the file MLton-LICENSE for details.
 ##

PATH := ../bin:$(shell echo $$PATH)

TARGET := self

ifeq ($(TARGET), self)
CC := gcc -std=gnu99
AR := ar rc
RANLIB := ranlib
else
CC := $(TARGET)-gcc -std=gnu99
AR := $(TARGET)-ar rc
RANLIB := $(TARGET)-ranlib
endif

TARGET_ARCH := $(shell ../bin/host-arch)
TARGET_OS := $(shell ../bin/host-os)
GCC_MAJOR_VERSION :=						\
	$(shell $(CC) -v 2>&1 | grep 'gcc version' | 		\
		sed 's/.*gcc version \([0-9][0-9]*\)\.\([0-9][0-9]*\).*/\1/')
GCC_MINOR_VERSION :=						\
	$(shell $(CC) -v 2>&1 | grep 'gcc version' | 		\
		sed 's/.*gcc version \([0-9][0-9]*\)\.\([0-9][0-9]*\).*/\2/')
GCC_VERSION := $(GCC_MAJOR_VERSION).$(GCC_MINOR_VERSION)

EXE :=

# These flags can be overridden by the user
CPPFLAGS :=
CFLAGS :=

WARNXCFLAGS :=
WARNXCFLAGS += -pedantic -Wall
ifeq ($(findstring $(GCC_MAJOR_VERSION), 3),$(GCC_MAJOR_VERSION))
WARNXCFLAGS += -W
endif
ifeq ($(findstring $(GCC_MAJOR_VERSION), 4),$(GCC_MAJOR_VERSION))
WARNXCFLAGS += -Wextra
endif
WARNXCFLAGS += -Wformat=2
ifeq ($(findstring $(GCC_MAJOR_VERSION), 4),$(GCC_MAJOR_VERSION))
WARNXCFLAGS += -Wswitch-default -Wswitch-enum
endif
WARNXCFLAGS += -Wuninitialized
ifeq ($(findstring $(GCC_MAJOR_VERSION), 4),$(GCC_MAJOR_VERSION))
WARNXCFLAGS += -Winit-self
endif
ifeq ($(findstring $(GCC_MAJOR_VERSION), 4),$(GCC_MAJOR_VERSION))
WARNXCFLAGS += -Wstrict-aliasing=2
endif
WARNXCFLAGS += -Wfloat-equal
WARNXCFLAGS += -Wundef
WARNXCFLAGS += -Wshadow
WARNXCFLAGS += -Wpointer-arith
WARNXCFLAGS += -Wbad-function-cast -Wcast-qual
WARNXCFLAGS += -Wwrite-strings
# WARNXCFLAGS += -Wconversion
WARNXCFLAGS += -Waggregate-return
WARNXCFLAGS += -Wstrict-prototypes
ifeq ($(findstring $(GCC_MAJOR_VERSION), 4),$(GCC_MAJOR_VERSION))
WARNXCFLAGS += -Wold-style-definition
endif
WARNXCFLAGS += -Wmissing-prototypes -Wmissing-declarations
ifeq ($(findstring $(GCC_MAJOR_VERSION), 4),$(GCC_MAJOR_VERSION))
WARNXCFLAGS += -Wmissing-field-initializers
endif
WARNXCFLAGS += -Wmissing-noreturn
WARNXCFLAGS += -Wmissing-format-attribute
# WARNXCFLAGS += -Wpacked
# WARNXCFLAGS += -Wpadded
WARNXCFLAGS += -Wredundant-decls
WARNXCFLAGS += -Wnested-externs
# WARNXCFLAGS += -Wunreachable-code

XCFLAGS := -fno-common $(WARNXCFLAGS)
OPTXCFLAGS := -Wdisabled-optimization -O2 -fomit-frame-pointer
DEBUGXCFLAGS := -DASSERT=1 -Wno-uninitialized -O0 -g
PICXCFLAGS :=

# Win32&64 don't use PIC code, all other platforms do
ifeq ($(findstring $(TARGET_OS), mingw cygwin),)
PICXCFLAGS += -fPIC
endif

# Make mlton library symbols private (win32&64 use another technique)
ifeq ($(findstring $(GCC_MAJOR_VERSION), 4),$(GCC_MAJOR_VERSION))
ifeq ($(findstring $(TARGET_OS), mingw cygwin),)
XCFLAGS += -fvisibility=hidden
endif
endif

ifeq ($(TARGET_ARCH), alpha)
XCFLAGS += -mieee -mbwx -mtune=ev6 -mfp-rounding-mode=d
endif

ifeq ($(TARGET_ARCH), amd64)
XCFLAGS += -m64
endif

ifeq ($(findstring $(TARGET_ARCH), hppa ia64 powerpc sparc),$(TARGET_ARCH))
ifeq (4.2, $(firstword $(sort $(GCC_VERSION) 4.2)))
# GMP headers contain C99 inline functions which generate warnings
# with a suggestion to use this flag to disable the warnings.
XCFLAGS += -fgnu89-inline
endif
endif

ifeq ($(TARGET_ARCH), ia64)
XCFLAGS += -mtune=itanium2
ifeq ($(TARGET_OS), hpux)
XCFLAGS += -mlp64
endif
endif

ifeq ($(TARGET_OS)-$(TARGET_ARCH), aix-powerpc64)
XCFLAGS += -maix64
AR := ar -X 64 rc
endif

ifeq ($(TARGET_ARCH), sparc)
XCFLAGS += -m32 -mcpu=v8 -Wa,-xarch=v8plusa
endif

ifeq ($(TARGET_ARCH), x86)
XCFLAGS += -m32
ifeq (3, $(firstword $(sort $(GCC_MAJOR_VERSION) 3)))
OPTXCFLAGS += -falign-loops=2 -falign-jumps=2 -falign-functions=5
else
OPTXCFLAGS += -malign-loops=2 -malign-jumps=2 -malign-functions=5
endif
endif

ifeq ($(TARGET_OS), cygwin)
EXE := .exe
endif

ifeq ($(TARGET_OS), darwin)
XCFLAGS += -I/usr/local/include -I/sw/include -I/opt/local/include
endif

ifeq ($(TARGET_OS), freebsd)
XCFLAGS += -I/usr/local/include
endif

ifeq ($(TARGET_OS), mingw)
EXE := .exe
# GCC doesn't recognize the %I64 format specifier which means %ll on windows
XCFLAGS += -Wno-format -Wno-missing-format-attribute
endif

ifeq ($(TARGET_OS), netbsd)
XCFLAGS += -I/usr/pkg/include
endif

ifeq ($(TARGET_OS), openbsd)
XCFLAGS += -I/usr/local/include
endif

ifeq ($(TARGET_OS), solaris)
XCFLAGS += -funroll-all-loops
endif


XCFLAGS += -I. -Iplatform
OPTCFLAGS := $(CFLAGS) $(CPPFLAGS) $(XCFLAGS) $(OPTXCFLAGS)
DEBUGCFLAGS := $(CFLAGS) $(CPPFLAGS) $(XCFLAGS) $(DEBUGXCFLAGS)
PICCFLAGS := $(OPTCFLAGS) $(PICXCFLAGS)

ALL := libgdtoa.a libgdtoa-gdb.a libgdtoa-pic.a \
       libmlton.a libmlton-gdb.a libmlton-pic.a
ALL += gen/c-types.sml gen/basis-ffi.sml gen/sizes

all: $(ALL)


### util ###

UTILHFILES :=							\
	util.h							\
	$(shell find util -type f | grep '\.h$$')
UTILCFILES :=							\
	$(shell find util -type f | grep '\.c$$')

util-pic.o: util.c $(UTILCFILES) cenv.h $(UTILHFILES)
	$(CC) $(PICCFLAGS) -c -o $@ $<
util-gdb.o: util.c $(UTILCFILES) cenv.h $(UTILHFILES)
	$(CC) $(DEBUGCFLAGS) -c -o $@ $<
util.o:     util.c $(UTILCFILES) cenv.h $(UTILHFILES)
	$(CC) $(OPTCFLAGS) -c -o $@ $<

### c-types.h  ml-types.h  gen/c-types.sml ###

c-types.h: gen/c-types.h
	cp $< $@
ml-types.h: gen/ml-types.h
	cp $< $@
gen/c-types.h gen/c-types.sml gen/ml-types.h: gen/gen-types.stamp
	@touch $@
gen/gen-types.stamp: gen/gen-types.c util.h util.o
	$(CC) $(OPTCFLAGS) -o gen/gen-types gen/gen-types.c util.o
	rm -f gen/c-types.h gen/c-types.sml gen/ml-types.h gen/gen-types.stamp
	cd gen && ./gen-types
	rm -f gen/gen-types$(EXE) gen/gen-types
	touch $@

### basis-ffi.h  gen/basis-ffi.sml ###

basis-ffi.h: gen/basis-ffi.h
	cp $< $@
gen/basis-ffi.h gen/basis-ffi.sml: gen/gen-basis-ffi.stamp
	@touch $@
gen/gen-basis-ffi.stamp: gen/gen-basis-ffi.sml gen/basis-ffi.def
	mlton -output gen/gen-basis-ffi gen/gen-basis-ffi.sml
	rm -f gen/basis-ffi.h gen/basis-ffi.sml gen/gen-basis-ffi.stamp
	cd gen && ./gen-basis-ffi
	rm -f gen/gen-basis-ffi
	touch $@

### libgdtoa ###

GDTOAHFILES := arith.h gdtoa.h
GDTOAHFILES := $(patsubst %,gdtoa/%,$(GDTOAHFILES))
GDTOACFILES :=									\
	dmisc.c     g_ddfmt.c   g_ffmt_p.c  gdtoa.c     misc.c      strtoIf.c   strtodI.c   strtopdd.c  strtord.c   sum.c \
	dtoa.c      g_ddfmt_p.c g_xLfmt.c   gethex.c    smisc.c     strtoIg.c   strtodg.c   strtopf.c   strtordd.c  ulp.c \
	g_Qfmt.c    g_dfmt.c    g_xLfmt_p.c gmisc.c     strtoIQ.c   strtoIx.c   strtof.c    strtopx.c   strtorf.c \
	g_Qfmt_p.c  g_dfmt_p.c  g_xfmt.c    hd_init.c   strtoId.c   strtoIxL.c  strtopQ.c   strtopxL.c  strtorx.c \
	g__fmt.c    g_ffmt.c    g_xfmt_p.c  hexnan.c    strtoIdd.c  strtod.c    strtopd.c   strtorQ.c   strtorxL.c
GDTOACFILES := $(patsubst %,gdtoa/%,$(GDTOACFILES))

GDTOA_OBJS       := $(patsubst %.c,%.o,$(GDTOACFILES))
GDTOA_DEBUG_OBJS := $(patsubst %.c,%-gdb.o,$(GDTOACFILES))
GDTOA_PIC_OBJS   := $(patsubst %.c,%-pic.o,$(GDTOACFILES))

gdtoa/README: gdtoa.tgz gdtoa.may_alias-unions.patch gdtoa.rename-public-fns.patch gdtoa.hide-private-fns.patch gdtoa.hide-public-fns.patch
	gzip -dc gdtoa.tgz | tar xf -
	patch -s -p0 <gdtoa.may_alias-unions.patch
	patch -s -p0 <gdtoa.rename-public-fns.patch
	patch -s -p0 <gdtoa.hide-private-fns.patch
	patch -s -p0 <gdtoa.hide-public-fns.patch
	@touch $@

gdtoa/gdtoa.h $(GDTOACFILES): gdtoa/README
	@touch $@

gdtoa/arithchk.c: gdtoa/README
	@touch $@

gdtoa/arithchk.out: gdtoa/arithchk.c
	cd gdtoa && $(CC) $(OPTCFLAGS) -w -O1 -o arithchk.out arithchk.c

gdtoa/arith.h: gdtoa/arithchk.out
	cd gdtoa && ./arithchk.out >arith.h

gdtoa/qnan.c: gdtoa/README
	@touch $@

gdtoa/qnan.out: gdtoa/arith.h gdtoa/qnan.c
	cd gdtoa && $(CC) $(OPTCFLAGS) -w -O1 -o qnan.out qnan.c

gdtoa/gd_qnan.h: gdtoa/qnan.out
	cd gdtoa && ./qnan.out >gd_qnan.h

gdtoa/%-pic.o: gdtoa/%.c gdtoa/arith.h gdtoa/gd_qnan.h
	$(CC) $(PICCFLAGS) -w -DINFNAN_CHECK -c -o $@ $<
gdtoa/%-gdb.o: gdtoa/%.c gdtoa/arith.h gdtoa/gd_qnan.h
	$(CC) $(DEBUGCFLAGS) -w -DINFNAN_CHECK -c -o $@ $<
gdtoa/%.o:     gdtoa/%.c gdtoa/arith.h gdtoa/gd_qnan.h
	$(CC) $(OPTCFLAGS) -w -DINFNAN_CHECK -c -o $@ $<

libgdtoa.a:     $(GDTOA_OBJS)
libgdtoa-gdb.a: $(GDTOA_DEBUG_OBJS)
libgdtoa-pic.a: $(GDTOA_PIC_OBJS)

### libmlton ###

PLATFORMHFILES :=						\
	platform.h						\
	$(shell find platform -type f | grep '\.h$$')
PLATFORMCFILES :=						\
	$(shell find platform -type f | grep '\.c$$')

GCHFILES :=							\
	gc.h							\
	$(shell find gc -type f | grep '\.h$$')
GCCFILES :=							\
	$(shell find gc -type f | grep '\.c$$')

BASISCFILES :=							\
	$(shell find basis -type f | grep '\.c$$')

HFILES :=							\
	cenv.h							\
	$(UTILHFILES)						\
	ml-types.h						\
	c-types.h						\
	basis-ffi.h						\
	$(PLATFORMHFILES)					\
	$(GCHFILES)

MLTON_OBJS := 							\
	util.o							\
	platform.o						\
	platform/$(TARGET_OS).o					\
	gc.o
MLTON_OBJS += $(foreach f, $(basename $(BASISCFILES)), $(f).o)
MLTON_DEBUG_OBJS := $(patsubst %.o,%-gdb.o,$(MLTON_OBJS))
MLTON_PIC_OBJS   := $(patsubst %.o,%-pic.o,$(MLTON_OBJS))

platform/$(TARGET_OS)-pic.o: $(PLATFORMCFILES)
platform/$(TARGET_OS)-gdb.o: $(PLATFORMCFILES)
platform/$(TARGET_OS).o:     $(PLATFORMCFILES)

gc-pic.o: $(GCCFILES)
gc-gdb.o: $(GCCFILES)
gc.o:     $(GCCFILES)

gc.c_XCFLAGS := -Wno-unreachable-code

basis/Real/Math-pic.o:  basis/Real/Math-fns.h
basis/Real/Math-gdb.o:  basis/Real/Math-fns.h
basis/Real/Math.o:      basis/Real/Math-fns.h
basis/Real/Real-pic.o:  basis/Real/Real-ops.h
basis/Real/Real-gdb.o:  basis/Real/Real-ops.h
basis/Real/Real.o:      basis/Real/Real-ops.h
basis/Real/Real.c_XCFLAGS := -Wno-float-equal
basis/Real/gdtoa-pic.o: $(GDTOAHFILES)
basis/Real/gdtoa-gdb.o: $(GDTOAHFILES)
basis/Real/gdtoa.o:     $(GDTOAHFILES)
basis/Real/strto-pic.o: $(GDTOAHFILES)
basis/Real/strto-gdb.o: $(GDTOAHFILES)
basis/Real/strto.o:     $(GDTOAHFILES)
basis/System/Date.c_XCFLAGS := -Wno-format-nonliteral
basis/Word/Word-pic.o:  basis/Word/Word-consts.h basis/Word/Word-ops.h basis/Word/Word-check.h
basis/Word/Word-gdb.o:  basis/Word/Word-consts.h basis/Word/Word-ops.h basis/Word/Word-check.h
basis/Word/Word.o:      basis/Word/Word-consts.h basis/Word/Word-ops.h basis/Word/Word-check.h
basis/coerce-pic.o:     basis/coerce.h
basis/coerce-gdb.o:     basis/coerce.h
basis/coerce.o:         basis/coerce.h
basis/cpointer-pic.o:   basis/cpointer.h
basis/cpointer-gdb.o:   basis/cpointer.h
basis/cpointer.o:       basis/cpointer.h

%-pic.o: %.c $(HFILES)
	$(CC) $(PICCFLAGS) $($(<)_XCFLAGS) -c -o $@ $<
%-gdb.o: %.c $(HFILES)
	$(CC) $(DEBUGCFLAGS) $($(<)_XCFLAGS) -c -o $@ $<
%.o: %.c $(HFILES)
	$(CC) $(OPTCFLAGS) $($(<)_XCFLAGS) -c -o $@ $<

libmlton.a: $(MLTON_OBJS)
libmlton-gdb.a: $(MLTON_DEBUG_OBJS)
libmlton-pic.a: $(MLTON_PIC_OBJS)

### gen/sizes ###

gen/sizes: gen/gen-sizes.stamp
	@touch $@
gen/gen-sizes.stamp: gen/gen-sizes.c libmlton.a $(HFILES)
	$(CC) $(OPTCFLAGS) -o gen/gen-sizes gen/gen-sizes.c -L. -lmlton
	rm -f gen/sizes
	cd gen && ./gen-sizes
	rm -f gen/gen-sizes$(EXE) gen/gen-sizes
	touch $@


######


%.a:
	rm -f $@
	$(AR) $@ $^
	$(RANLIB) $@



.PHONY: flags
flags:
	echo TARGET = $(TARGET)
	echo TARGET_ARCH = $(TARGET_ARCH)
	echo TARGET_OS = $(TARGET_OS)
	echo GCC_MAJOR_VERSION = $(GCC_MAJOR_VERSION)
	echo GCC_MINOR_VERSION = $(GCC_MINOR_VERSION)
	echo GCC_VERSION = $(GCC_VERSION)
	echo EXE = $(EXE)
	echo OPTXCFLAGS = $(OPTXCFLAGS)
	echo DEBUGXCFLAGS = $(DEBUGXCFLAGS)
	echo PICXCFLAGS = $(PICXCFLAGS)


.PHONY: clean
clean:
	../bin/clean

=== Doc/latex/Makefile ===
#
# This file compiles the documentation 
#

TEX= sml.tex mlrisc.tex mltexdoc.tex
DVI=	$(TEX:.tex=.dvi)
PS=	$(TEX:.tex=.ps)
PDF=	$(TEX:.tex=.pdf)

all:	pictures $(DVI) $(PS)

pictures:
	(cd ../pictures; make)

again:	cleandvi bib
	make

cleandvi:
	rm -f $(TEX:.tex=.dvi)

bib:
	for f in $(TEX:.tex=) ; do bibtex $$f; done

pdf:	$(PDF)

%.dvi:	%.tex sml.sty mltex.sty
	latex $(@:.dvi=.tex)

%.ps:	%.dvi
	dvips -D 600 -t letter $(@:.ps=.dvi) -o

%.pdf:	%.ps
	ps2pdf $<

mlrisc.dvi: annotations.tex graphics.tex instructions.tex mltree.tex \
	delayslots.tex cells.tex cluster.tex constants.tex \
	pseudo-ops.tex streams.tex labelexp.tex labels.tex regions.tex \
	regmap.tex graphs.tex mlrisc-ir.tex compiler-graphs.tex \
	SSA.tex VLIW.tex ra.tex ILP.tex mlrisc-arch.tex \
	future-work.tex asm.tex mc.tex instrsel.tex \
	availability.tex gc.tex mlrisc-gen.tex contributions.tex \
	systems.tex mlrisc-graphics.tex contributors.tex \
	requirements.tex INTRO.tex problem.tex mlrisc-compiler.tex \
	mlrisc-ir-rep.tex backend-opt.tex sys-integration.tex \
	optimizations.tex span-dep.tex mlrisc-md.tex line-counts.tex \
	sparc.tex alpha.tex x86.tex ppc.tex mips.tex hppa.tex C6.tex \
	mltree-ext.tex mltree-util.tex

mltexdoc.dvi:	mltex.tex

clean:	
	/bin/rm -f $(DVI) *.aux *.log *.bbl *.blg

=== doc/guide/Makefile ===
export LC_ALL = C

NULL :=

ASCIIDOC := asciidoc
ifneq ($(shell which $(ASCIIDOC) 2> /dev/null),)
ASCIIDOC_CONF_DIR := $(shell $(ASCIIDOC) -v /dev/null 2>&1 | head -n 1 | sed 's|.*reading: \(.*\)/asciidoc.conf|\1|')
else
ASCIIDOC_CONF_DIR :=
endif
ASCIIDOC_MLTON_FLAGS := $(shell cat conf/asciidoc-mlton.flags | sed 's|^\#.*||')
ASCIIDOC_MLTON_DEPS := bin/InclGitFile.py conf/asciidoc-mlton.flags $(shell cat conf/asciidoc-mlton.flags | sed -n 's|^.*\(conf/.*\)$$|\1|p')
ASCIIDOC_HTML5_FLAGS := $(ASCIIDOC_MLTON_FLAGS) $(shell cat conf/asciidoc-html5.flags | sed 's|^\#.*||')
ASCIIDOC_HTML5_DEPS := $(ASCIIDOC_MLTON_DEPS) conf/asciidoc-html5.flags $(shell cat conf/asciidoc-html5.flags | sed -n 's|^.*\(conf/.*\)$$|\1|p')
ASCIIDOC_DOCBOOK45_FLAGS := $(ASCIIDOC_MLTON_FLAGS) $(shell cat conf/asciidoc-docbook45.flags | sed 's|^\#.*||')
ASCIIDOC_DOCBOOK45_DEPS := $(ASCIIDOC_MLTON_DEPS) conf/asciidoc-docbook45.flags $(shell cat conf/asciidoc-docbook45.flags | sed -n 's|^.*\(conf/.*\)$$|\1|p')

DBLATEX := dblatex

GEN_PAGES := Index mlton-guide
GEN_ATTACHMENTS := $(foreach size,16 32 64 128 256 512 1024,Logo.attachments/mlton-$(size).png Logo.attachments/mlton-$(size).pdf)

SRC_PAGES := $(filter-out $(GEN_PAGES),$(patsubst ./%.txt,%,$(shell cd txt ; find . -type f -name '*.txt')))
SRC_ATTACHMENTS := $(filter-out $(GEN_ATTACHMENTS),$(patsubst ./%,%,$(foreach dir,$(shell cd txt ; find . -type d -name '*.attachments'),$(shell cd txt ; find $(dir) -type f ! -name '.gitignore' ! -name '.gitattributes'))))

HTML5_XTRA := asciidoc.css asciidoc.js pygments.css mlton.css mlton-gcse.js index.html
HTML5_XTRA_PAGES := Index

MLTON_ORG_XTRA := $(HTML5_XTRA)
MLTON_ORG_XTRA_PAGES := $(HTML5_XTRA_PAGES)
MLTON_ORG_XTRA_ATTACHMENTS := $(foreach size,16 32 64 128 256 512 1024,Logo.attachments/mlton-$(size).png)
MLTON_ORG := $(addprefix www.mlton.org/, $(SRC_PAGES) $(SRC_ATTACHMENTS) $(MLTON_ORG_XTRA) $(MLTON_ORG_XTRA_PAGES) $(MLTON_ORG_XTRA_ATTACHMENTS))
MLTON_ORG_TORM := $(filter-out $(MLTON_ORG),$(shell if [ -d www.mlton.org ]; then find www.mlton.org -type f; fi))

LOCALHOST_XTRA := $(filter-out mlton-gcse.js,$(HTML5_XTRA))
LOCALHOST_XTRA_PAGES := $(HTML5_XTRA_PAGES)
LOCALHOST_XTRA_ATTACHMENTS := $(foreach size,16 32 64 128 256 512 1024,Logo.attachments/mlton-$(size).png)
LOCALHOST := $(addprefix localhost/, $(SRC_PAGES) $(SRC_ATTACHMENTS) $(LOCALHOST_XTRA) $(LOCALHOST_XTRA_PAGES) $(LOCALHOST_XTRA_ATTACHMENTS))
LOCALHOST_TORM := $(filter-out $(LOCALHOST),$(shell if [ -d localhost ]; then find localhost -type f; fi))


ALL :=
ifneq ($(shell which $(ASCIIDOC) 2> /dev/null),)
ifneq ($(shell which pygmentize 2> /dev/null),)
ALL += $(LOCALHOST) localhost-rm
endif
ifneq ($(shell which $(DBLATEX) 2> /dev/null),)
ALL += mlton-guide.pdf
endif
endif


all: $(ALL)


ifneq ($(shell which gm 2> /dev/null),)
CONVERT := gm convert
else
ifneq ($(shell which convert 2> /dev/null),)
CONVERT := convert
else
CONVERT := no-convert
endif
endif

%-16.png : %.svg
	$(CONVERT) $< -resize 16x16 $@
%-32.png : %.svg
	$(CONVERT) $< -resize 32x32 $@
%-64.png : %.svg
	$(CONVERT) $< -resize 64x64 $@
%-128.png : %.svg
	$(CONVERT) $< -resize 128x128 $@
%-256.png : %.svg
	$(CONVERT) $< -resize 256x256 $@
%-512.png : %.svg
	$(CONVERT) $< -resize 512x512 $@
%-1024.png : %.svg
	$(CONVERT) $< -resize 1024x1024 $@

%-16.pdf : %.svg
	$(CONVERT) $< -resize 16x16 $@
%-32.pdf : %.svg
	$(CONVERT) $< -resize 32x32 $@
%-64.pdf : %.svg
	$(CONVERT) $< -resize 64x64 $@
%-128.pdf : %.svg
	$(CONVERT) $< -resize 128x128 $@
%-256.pdf : %.svg
	$(CONVERT) $< -resize 256x256 $@
%-512.pdf : %.svg
	$(CONVERT) $< -resize 512x512 $@
%-1024.pdf : %.svg
	$(CONVERT) $< -resize 1024x1024 $@


conf/specialsections.conf : $(ASCIIDOC_CONF_DIR)/lang-en.conf bin/mk-specialsections-conf.sh
	./bin/mk-specialsections-conf.sh $< $@

conf/html5-header.conf : $(ASCIIDOC_CONF_DIR)/html5.conf bin/mk-html5-header-conf.sh
	./bin/mk-html5-header-conf.sh $< $@

conf/html5-footer.conf : $(ASCIIDOC_CONF_DIR)/html5.conf bin/mk-html5-footer-conf.sh
	./bin/mk-html5-footer-conf.sh $< $@


txt/Index.txt : bin/mk-index.sh $(foreach page,$(SRC_PAGES),txt/$(page).txt)
	./bin/mk-index.sh $(SRC_PAGES) > $@

txt/mlton-guide.txt : bin/mk-mlton-guide.sh $(foreach page,$(SRC_PAGES),txt/$(page).txt)
	./bin/mk-mlton-guide.sh $(SRC_PAGES) > $@


$(ASCIIDOC_CONF_DIR)/stylesheets/asciidoc.css: ;
%/asciidoc.css : $(ASCIIDOC_CONF_DIR)/stylesheets/asciidoc.css
	mkdir -p $(dir $@) ; cp $< $@

$(ASCIIDOC_CONF_DIR)/javascripts/asciidoc.js: ;
%/asciidoc.js : $(ASCIIDOC_CONF_DIR)/javascripts/asciidoc.js
	mkdir -p $(dir $@) ; cp $< $@

$(ASCIIDOC_CONF_DIR)/stylesheets/pygments.css: ;
%/pygments.css : $(ASCIIDOC_CONF_DIR)/stylesheets/pygments.css
	mkdir -p $(dir $@) ; cp $< $@

conf/mlton.css: ;
%/mlton.css : conf/mlton.css
	mkdir -p $(dir $@) ; cp $< $@

conf/mlton-gcse.js: ;
%/mlton-gcse.js : conf/mlton-gcse.js
	mkdir -p $(dir $@) ; cp $< $@

%/index.html : %/Home
	rm -f $@ ; mkdir -p $(dir $@) ; ln -s Home $@ ; touch $@


www.mlton.org/% : txt/%.txt $(ASCIIDOC_HTML5_DEPS) bin/mk-git-attribute-entity-flags.sh
	mkdir -p $(dir $@) ; $(ASCIIDOC) $(ASCIIDOC_HTML5_FLAGS) $(shell ./bin/mk-git-attribute-entity-flags.sh $<) -a mlton-guide-host=www.mlton.org -a mlton-guide-page=$(basename $(notdir $<)) -o $@ $<

www.mlton.org/% : txt/%
	mkdir -p $(dir $@) ; cp -prf $< $@

.PHONY: www.mlton.org-rm
www.mlton.org-rm: $(MLTON_ORG)
	@rm -rf $(MLTON_ORG_TORM)

.PHONY: www.mlton.org
www.mlton.org: $(MLTON_ORG)

.PHONY: upload_www.mlton.org
upload_www.mlton.org: $(MLTON_ORG) www.mlton.org-rm
	rsync -avzP --delete -e ssh www.mlton.org/ fluet,mlton@web.sourceforge.net:htdocs/wiki


localhost/% : txt/%.txt $(ASCIIDOC_HTML5_DEPS)
	mkdir -p $(dir $@) ; $(ASCIIDOC) $(ASCIIDOC_HTML5_FLAGS) -a mlton-guide-host=localhost -a mlton-guide-page=$(basename $(notdir $<)) -o $@ $<

localhost/% : txt/%
	mkdir -p $(dir $@) ; cp -prf $< $@

.PHONY: localhost-rm
localhost-rm: $(LOCALHOST)
	@rm -rf $(LOCALHOST_TORM)

.PHONY: localhost
localhost: $(LOCALHOST) localhost-rm

txt/mlton-guide.xml : txt/mlton-guide.txt conf/asciidoc-docbook45.flags $(ASCIIDOC_DOCBOOK45_DEPS)
	mkdir -p $(dir $@) ; $(ASCIIDOC) $(ASCIIDOC_DOCBOOK45_FLAGS) -o $@ $<
	@true || xmllint --nonet --noout --valid $@ || true
mlton-guide.pdf : txt/mlton-guide.xml txt/Logo.attachments/mlton-128.pdf conf/mlton-dblatex.xsl conf/mlton-dblatex.sty
	$(DBLATEX) -t pdf -p conf/mlton-dblatex.xsl -s conf/mlton-dblatex.sty -o $@ $<


.PHONY: check-git-links
check-git-links:
	@./bin/check-git-links.sh $(SRC_PAGES)

.PHONY: clean
clean:
	../../bin/clean

.PHONY: vars
vars:
	@echo ASCIIDOC_CONF_DIR=$(ASCIIDOC_CONF_DIR)
	@echo ASCIIDOC_HTML5_FLAGS=$(ASCIIDOC_HTML5_FLAGS)
	@echo ASCIIDOC_HTML5_DEPS=$(ASCIIDOC_HTML5_DEPS)
	@echo GEN_PAGES=$(GEN_PAGES)
	@echo GEN_ATTACHMENTS=$(GEN_ATTACHMENTS)
	@echo SRC_PAGES=$(SRC_PAGES)
	@echo SRC_ATTACHMENTS=$(SRC_ATTACHMENTS)

=== debian/changelog ===
mlton (20130715-3) unstable; urgency=low

  * Build-depend only on mlton-compiler and mlton-tools
   * Buildds got stuck by looking at the mlton all package
  * Remove heap-size hacks; debian buildds have >2GB RAM now
  * Source-only upload to ensure full rebuild

 -- Wesley W. Terpstra <terpstra@debian.org>  Sun, 18 Dec 2016 22:48:17 +0100

mlton (20130715-2) unstable; urgency=low

  * Remove policy-problematic smlnj HTML4 from the package
  * Remove ports for hurd-i386 (unreliable) and ia64 (dead)
  * Add arm64 port (use supplied patch; closes: #791936)
  * Add mips64el port (needed a complete arch patch)
  * Add ppc64el port (needs bin/platform patch)
  * Track s390 port name change to s390x
  * Fix kfreebsd ports (removed getpgrp work-around)
  * Added build dependency on librsvg2-bin

 -- Wesley W. Terpstra <terpstra@debian.org>  Sat, 17 Dec 2016 03:39:49 +0100

mlton (20130715-1) unstable; urgency=low

  * New upstream release (closes: #762143)
  * Always build PIC on Linux (closes: #837567)
  * Bump debhelper compat to 9 (disable empty dbgsym packages)
  * Bump standards version to 3.9.8 (use DEB_HOST_MULTIARCH)
  * Replace README link with contents to help dh_installdocs

 -- Wesley W. Terpstra <terpstra@debian.org>  Fri, 9 Dec 2016 12:11:32 +0200

=== debian/control ===
Source: mlton
Section: devel
Priority: optional
Maintainer: Wesley W. Terpstra <terpstra@debian.org>
Build-Depends: mlton-compiler, mlton-tools, libgmp-dev, htmldoc, texlive-latex-base, procps, debhelper (>= 9.0.0), cdbs (>= 0.4.52), quilt, binutils (>= 2.21.51.201104) [mips mipsel], gcc (>= 4:4.6.0-5) [mips mipsel], asciidoc, dblatex, ruby-albino, imagemagick, librsvg2-bin
Standards-Version: 3.9.8

Package: mlton
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, mlton-compiler (>= ${source:Version}), mlton-compiler (<< ${source:Version}.1~), mlton-tools (>= ${source:Version}), mlton-tools (<< ${source:Version}.1~), mlton-doc (= ${source:Version})
Homepage: http://mlton.org/
Description: Optimizing compiler for Standard ML
 MLton is a whole-program optimizing compiler
 for Standard ML.  MLton generates standalone 
 executables with excellent runtime performance,
 is SML 97 compliant, and has a complete basis
 library.  MLton has source-level profiling,
 a fast C FFI, an interface to the GNU
 multiprecision library, and lots of useful
 libraries.
 .
 This metapackage depends on all MLton packages.

Package: mlton-basis
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Breaks: mlton (<< 20100608-3)
Replaces: mlton (<< 20100608-3)
Homepage: http://mlton.org/
Description: Optimizing compiler for Standard ML - basis library
 MLton is a whole-program optimizing compiler
 for Standard ML.  MLton generates standalone 
 executables with excellent runtime performance,
 is SML 97 compliant, and has a complete basis
 library.  MLton has source-level profiling,
 a fast C FFI, an interface to the GNU
 multiprecision library, and lots of useful
 libraries.
 .
 This package includes the cross-platform basis.

Package: mlton-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Breaks: mlton (<< 20100608-3)
Replaces: mlton (<< 20100608-3)
Homepage: http://mlton.org/
Description: Optimizing compiler for Standard ML - documentation
 MLton is a whole-program optimizing compiler
 for Standard ML.  MLton generates standalone 
 executables with excellent runtime performance,
 is SML 97 compliant, and has a complete basis
 library.  MLton has source-level profiling,
 a fast C FFI, an interface to the GNU
 multiprecision library, and lots of useful
 libraries.
 .
 This package includes non-man-page documentation.

Package: mlton-compiler
Architecture: alpha amd64 arm64 armel armhf hppa i386 kfreebsd-i386 kfreebsd-amd64 mips64el mips mipsel powerpc ppc64el s390x sparc
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}, gcc, libc6-dev, libgmp-dev, mlton-basis (= ${source:Version}), mlton-runtime-native (= ${binary:Version}) | mlton-runtime
Breaks: mlton (<< 20100608-3)
Replaces: mlton (<< 20100608-3)
Homepage: http://mlton.org/
Description: Optimizing compiler for Standard ML - compiler
 MLton is a whole-program optimizing compiler
 for Standard ML.  MLton generates standalone 
 executables with excellent runtime performance,
 is SML 97 compliant, and has a complete basis
 library.  MLton has source-level profiling,
 a fast C FFI, an interface to the GNU
 multiprecision library, and lots of useful
 libraries.
 .
 This package includes the compiler itself.

Package: mlton-tools
Architecture: alpha amd64 arm64 armel armhf hppa i386 kfreebsd-i386 kfreebsd-amd64 mips64el mips mipsel powerpc ppc64el s390x sparc
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: mlton (<< 20100608-3)
Replaces: mlton (<< 20100608-3)
Homepage: http://mlton.org/
Description: Optimizing compiler for Standard ML - tools
 MLton is a whole-program optimizing compiler
 for Standard ML.  MLton generates standalone 
 executables with excellent runtime performance,
 is SML 97 compliant, and has a complete basis
 library.  MLton has source-level profiling,
 a fast C FFI, an interface to the GNU
 multiprecision library, and lots of useful
 libraries.
 .
 This package includes tools which autogenerate SML.

Package: mlton-runtime-native
Architecture: alpha amd64 arm64 armel armhf hppa i386 kfreebsd-i386 kfreebsd-amd64 mips64el mips mipsel powerpc ppc64el s390x sparc
Depends: ${misc:Depends}, mlton-runtime-alpha-linux-gnu (= ${binary:Version}) [alpha] | mlton-runtime-x86-64-linux-gnu (= ${binary:Version}) [amd64] | mlton-runtime-aarch64-linux-gnu (= ${binary:Version}) [arm64] | mlton-runtime-arm-linux-gnueabi (= ${binary:Version}) [armel] | mlton-runtime-arm-linux-gnueabihf (= ${binary:Version}) [armhf] | mlton-runtime-hppa-linux-gnu (= ${binary:Version}) [hppa] | mlton-runtime-i486-linux-gnu (= ${binary:Version}) [i386] | mlton-runtime-i486-kfreebsd-gnu (= ${binary:Version}) [kfreebsd-i386] | mlton-runtime-x86-64-kfreebsd-gnu (= ${binary:Version}) [kfreebsd-amd64] | mlton-runtime-mips64el-linux-gnuabi64 (= ${binary:Version}) [mips64el] | mlton-runtime-mips-linux-gnu (= ${binary:Version}) [mips] | mlton-runtime-mipsel-linux-gnu (= ${binary:Version}) [mipsel] | mlton-runtime-powerpc-linux-gnu (= ${binary:Version}) [powerpc] | mlton-runtime-powerpc64le-linux-gnu (= ${binary:Version}) [ppc64el] | mlton-runtime-s390x-linux-gnu (= ${binary:Version}) [s390x] | mlton-runtime-sparc-linux-gnu (= ${binary:Version}) [sparc]
Homepage: http://mlton.org/
Description: Optimizing compiler for Standard ML - native runtime libraries
 MLton is a whole-program optimizing compiler
 for Standard ML.  MLton generates standalone 
 executables with excellent runtime performance,
 is SML 97 compliant, and has a complete basis
 library.  MLton has source-level profiling,
 a fast C FFI, an interface to the GNU
 multiprecision library, and lots of useful
 libraries.
 .
 This metapackage depends on native target libraries.

Package: mlton-runtime-alpha-linux-gnu
Architecture: alpha
Multi-Arch: foreign
Depends: ${misc:Depends}, mlton-basis (= ${source:Version})
Provides: mlton-runtime
Homepage: http://mlton.org/
Description: Optimizing compiler for Standard ML - alpha runtime libraries
 MLton is a whole-program optimizing compiler
 for Standard ML.  MLton generates standalone 
 executables with excellent runtime performance,
 is SML 97 compliant, and has a complete basis
 library.  MLton has source-level profiling,
 a fast C FFI, an interface to the GNU
 multiprecision library, and lots of useful
 libraries.
 .
 This package provides alpha target libraries.

Package: mlton-runtime-x86-64-linux-gnu
Architecture: amd64
Multi-Arch: foreign
Depends: ${misc:Depends}, mlton-basis (= ${source:Version})
Provides: mlton-runtime
Homepage: http://mlton.org/
Description: Optimizing compiler for Standard ML - amd64 runtime libraries
 MLton is a whole-program optimizing compiler
 for Standard ML.  MLton generates standalone 
 executables with excellent runtime performance,
 is SML 97 compliant, and has a complete basis
 library.  MLton has source-level profiling,
 a fast C FFI, an interface to the GNU
 multiprecision library, and lots of useful
 libraries.
 .
 This package provides x86-64 target libraries.

Package: mlton-runtime-aarch64-linux-gnu
Architecture: arm64
Multi-Arch: foreign
Depends: ${misc:Depends}, mlton-basis (= ${source:Version})
Provides: mlton-runtime
Homepage: http://mlton.org/
Description: Optimizing compiler for Standard ML - arm64 runtime libraries
 MLton is a whole-program optimizing compiler
 for Standard ML.  MLton generates standalone 
 executables with excellent runtime performance,
 is SML 97 compliant, and has a complete basis
 library.  MLton has source-level profiling,
 a fast C FFI, an interface to the GNU
 multiprecision library, and lots of useful
 libraries.
 .
 This package provides arm64 target libraries.

Package: mlton-runtime-arm-linux-gnueabi
Architecture: armel
Multi-Arch: foreign
Depends: ${misc:Depends}, mlton-basis (= ${source:Version})
Provides: mlton-runtime
Homepage: http://mlton.org/
Description: Optimizing compiler for Standard ML - armel runtime libraries
 MLton is a whole-program optimizing compiler
 for Standard ML.  MLton generates standalone 
 executables with excellent runtime performance,
 is SML 97 compliant, and has a complete basis
 library.  MLton has source-level profiling,
 a fast C FFI, an interface to the GNU
 multiprecision library, and lots of useful
 libraries.
 .
 This package provides arm target libraries.

Package: mlton-runtime-arm-linux-gnueabihf
Architecture: armhf
Multi-Arch: foreign
Depends: ${misc:Depends}, mlton-basis (= ${source:Version})
Provides: mlton-runtime
Homepage: http://mlton.org/
Description: Optimizing compiler for Standard ML - armhf runtime libraries
 MLton is a whole-program optimizing compiler
 for Standard ML.  MLton generates standalone 
 executables with excellent runtime performance,
 is SML 97 compliant, and has a complete basis
 library.  MLton has source-level profiling,
 a fast C FFI, an interface to the GNU
 multiprecision library, and lots of useful
 libraries.
 .
 This package provides armhf target libraries.

Package: mlton-runtime-hppa-linux-gnu
Architecture: hppa
Multi-Arch: foreign
Depends: ${misc:Depends}, mlton-basis (= ${source:Version})
Provides: mlton-runtime
Homepage: http://mlton.org/
Description: Optimizing compiler for Standard ML - hppa runtime libraries
 MLton is a whole-program optimizing compiler
 for Standard ML.  MLton generates standalone 
 executables with excellent runtime performance,
 is SML 97 compliant, and has a complete basis
 library.  MLton has source-level profiling,
 a fast C FFI, an interface to the GNU
 multiprecision library, and lots of useful
 libraries.
 .
 This package provides hppa target libraries.

Package: mlton-runtime-i486-linux-gnu
Architecture: i386
Multi-Arch: foreign
Depends: ${misc:Depends}, mlton-basis (= ${source:Version})
Provides: mlton-runtime
Homepage: http://mlton.org/
Description: Optimizing compiler for Standard ML - i386 runtime libraries
 MLton is a whole-program optimizing compiler
 for Standard ML.  MLton generates standalone 
 executables with excellent runtime performance,
 is SML 97 compliant, and has a complete basis
 library.  MLton has source-level profiling,
 a fast C FFI, an interface to the GNU
 multiprecision library, and lots of useful
 libraries.
 .
 This package provides i486 target libraries.

Package: mlton-runtime-i486-kfreebsd-gnu
Architecture: kfreebsd-i386
Multi-Arch: foreign
Depends: ${misc:Depends}, mlton-basis (= ${source:Version})
Provides: mlton-runtime
Homepage: http://mlton.org/
Description: Optimizing compiler for Standard ML - kfreebsd-i386 runtime libraries
 MLton is a whole-program optimizing compiler
 for Standard ML.  MLton generates standalone 
 executables with excellent runtime performance,
 is SML 97 compliant, and has a complete basis
 library.  MLton has source-level profiling,
 a fast C FFI, an interface to the GNU
 multiprecision library, and lots of useful
 libraries.
 .
 This package provides kfreebsd i386 target libraries.

Package: mlton-runtime-x86-64-kfreebsd-gnu
Architecture: kfreebsd-amd64
Multi-Arch: foreign
Depends: ${misc:Depends}, mlton-basis (= ${source:Version})
Provides: mlton-runtime
Homepage: http://mlton.org/
Description: Optimizing compiler for Standard ML - kfreebsd-amd64 runtime libraries
 MLton is a whole-program optimizing compiler
 for Standard ML.  MLton generates standalone 
 executables with excellent runtime performance,
 is SML 97 compliant, and has a complete basis
 library.  MLton has source-level profiling,
 a fast C FFI, an interface to the GNU
 multiprecision library, and lots of useful
 libraries.
 .
 This package provides kfreebsd amd64 target libraries.

Package: mlton-runtime-mips64el-linux-gnuabi64
Architecture: mips64el
Multi-Arch: foreign
Depends: ${misc:Depends}, mlton-basis (= ${source:Version})
Provides: mlton-runtime
Homepage: http://mlton.org/
Description: Optimizing compiler for Standard ML - mips64el runtime libraries
 MLton is a whole-program optimizing compiler
 for Standard ML.  MLton generates standalone

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/makefile.mk
include /usr/share/cdbs/1/rules/patchsys-quilt.mk

# MLton compiles optimized, debug, and pic versions on its own.
DEB_MAKE_INVOKE = $(DEB_MAKE_ENVVARS) make -C $(DEB_BUILDDIR)

# The MLton guide is html. Don't compress example .sml files.
DEB_COMPRESS_EXCLUDE_ALL = mlton/guide .sml

DEB_MAKE_CLEAN_TARGET   = clean
DEB_MAKE_BUILD_TARGET   = all
DEB_MAKE_INSTALL_TARGET = install-no-strip DESTDIR=$(CURDIR)/debian/tmp/ PREFIX=/usr MAN_PREFIX_EXTRA=/share
DEB_MAKE_CHECK_TARGET   = check

DEB_DH_STRIP_ARGS_DEFAULT = --no-automatic-dbgsym

# Useful when inspecting build logs
common-configure-arch::
	free

# Move MLton target to per-architecture path
common-install-arch::
	mv $(CURDIR)/debian/tmp/usr/lib/mlton/targets/self $(CURDIR)/debian/tmp/usr/lib/mlton/targets/$(DEB_HOST_MULTIARCH)
	ln -s $(DEB_HOST_MULTIARCH) $(CURDIR)/debian/tmp/usr/lib/mlton/targets/self

# Remove licenses and empty directories to appease lintian
common-install-indep::
	rm README; cp doc/README .
	rm -f $(CURDIR)/debian/tmp/usr/lib/mlton/sml/smlnj-lib/HTML4/helper.py # we don't need a python dependency for an unrelated helper script
	rm -f $(CURDIR)/debian/tmp/usr/lib/mlton/sml/smlnj-lib/HTML4/tests/test001.html # would reveal user IP if loaded due to external validation image
	find $(CURDIR)/debian/tmp -type d -empty -delete
	if test -n "$(DEB_ISNATIVE)"; then mv \
		$(CURDIR)/debian/tmp/usr/share/doc/mlton/changelog \
		$(CURDIR)/debian/tmp/usr/share/doc/mlton/changelog.PreviousRelease; \
	fi
